//treina.cpp - treina rede para distinguir elipses e retangulos
//compila treina -c -t
//Taxa de erro de validacao: 0%
//Tempo de execucao: 1,5 min
#include "csv.h"

int main(int argc, char** argv) {
  ARQCSV a("treino.csv");
  ARQCSV v("valida.csv");
 
  int n_train_epochs=10;
  int n_minibatch=10;
  
  network<sequential> net;
  net << conv(32, 32, 5, 1, 40) 
      << max_pool(28, 28, 40, 2) << relu() 
      << conv(14, 14, 5, 40, 80) 
      << max_pool(10, 10, 80, 2) << relu()
      << fc(5*5*80, 200) << relu()
      << fc(200, 20) << relu()
      << fc(20, 2);

  aumentaTreino(a.x,a.y,32,32,1,false,true); //espelha, diagonais

  adam optimizer;
  optimizer.alpha = 5e-5;
  cout << "Learning rate=" << optimizer.alpha << endl;
  int sucesso_anterior=0;

  cout << "start training" << endl;
  progress_display disp(a.x.size());
  timer t;

  int epoch = 1;
  int omelhor=-1;
  auto on_enumerate_epoch = [&]() {
    cout << "Epoch " << epoch << "/" << n_train_epochs << " finished. "
              << t.elapsed() << "s elapsed. ";
    ++epoch;
    result res = net.test(v.x, v.y);
    cout << "Validacao: " << res.num_success << "/" << res.num_total << endl;
    if (res.num_success<=sucesso_anterior && optimizer.alpha>5e-6) {
      optimizer.alpha *= 0.80;
      cout << "Learning rate=" << optimizer.alpha << endl;
    }
    sucesso_anterior=res.num_success;
    
    if (omelhor<=res.num_success) {
      omelhor=res.num_success;
      string nomearq = semDiret(string(argv[0]))+".net";
      net.save(nomearq);
      cout << "Gravado arquivo " << nomearq << endl;
    }

    disp.restart(a.x.size());
    t.restart();
  };

  auto on_enumerate_minibatch = [&]() { disp += n_minibatch; };

  net.train<mse>(optimizer, a.x, a.y, n_minibatch,
                 n_train_epochs, on_enumerate_minibatch, on_enumerate_epoch);

  cout << "end training." << endl;
}

 
